Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.expr
Class AxisExpression

    java.lang.Object
      net.sf.saxon.expr.ComputedExpression
          net.sf.saxon.expr.AxisExpression

All Implemented Interfaces:
  Container, Expression, InstructionInfoProvider, java.io.Serializable, javax.xml.transform.SourceLocator

public final class AxisExpression
extends ComputedExpression

An AxisExpression is always obtained by simplifying a PathExpression. It represents a PathExpression that starts at the context node, and uses a simple node-test with no filters. For example "*", "title", "./item", "@*", or "ancestor::chapter*".

An AxisExpression delivers nodes in axis order (not in document order). To get nodes in document order, in the case of a reverse axis, the expression should be wrapped in a Reverser.

See Also:
  Serialized Form

Field Summary

Fields inherited from class net.sf.saxon.expr.ComputedExpression
`locationId, staticProperties`

Fields inherited from interface net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, PROCESS_METHOD`

Constructor Summary
`AxisExpression(byte axis, NodeTest nodeTest)` Constructor

Method Summary
`Expression` | `analyze(StaticContext env, ItemType contextItemType)` Type-check the expression
`int` | `computeCardinality()` Specify that the expression returns a singleton
`int` | `computeSpecialProperties()` Get the static properties of this expression (other than its type).
`void` | `display(int level, NamePool pool, java.io.PrintStream out)` Diagnostic print of expression structure
`boolean` | `equals(java.lang.Object other)` Is this expression the same as another expression?
`byte` | `getAxis()` Get the axis
`int` | `getIntrinsicDependencies()` Determine which aspects of the context the expression depends on.
`ItemType` | `getItemType()` Determine the data type of the items returned by this expression
`NodeTest` | `getNodeTest()` Get the NodeTest.
`int` | `hashCode()` get HashCode for comparing two expressions
`SequenceIterator` | `iterate(XPathContext context)` Evaluate the path-expression in a given context to return a NodeSet
`Expression` | `simplify(StaticContext env)` Simplify an expression
`java.lang.String` | `toString()` Represent the expression as a string for diagnostics

Methods inherited from class net.sf.saxon.expr.ComputedExpression
`adoptChildExpression, checkPermittedContents, computeDependencies, computeStaticProperties, dynamicError, dynamicError, effectiveBooleanValue, evaluateAsString, evaluateItem, getCardinality, getColumnNumber, getConstructType, getDependencies, getExecutable, getImplementationMethod, getInstructionInfo, getLineNumber, getLocationId, getParentExpression, getPublicId, getSpecialProperties, getSystemId, iterateSubExpressions, markTailFunctionCalls, process, promote, resetStaticProperties, setLocationId, setParentExpression, typeError, typeError`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Constructor Detail

### AxisExpression

    public AxisExpression(byte axis,
                          NodeTest nodeTest)

  Constructor

Parameters:
  `axis` - The axis to be used in this AxisExpression: relevant constants are defined in class net.sf.saxon.om.Axis.
  `nodeTest` - The conditions to be satisfied by selected nodes. May be null, indicating that any node on the axis is acceptable
See Also:
  `Axis`

Method Detail

### simplify

    public Expression simplify(StaticContext env)

  Simplify an expression

  Specified by:
    `simplify` in interface `Expression`
  Overrides:
    `simplify` in class `ComputedExpression`
  Returns:
    the simplified expression

### analyze

    public Expression analyze(StaticContext env,
                              ItemType contextItemType)
                       throws XPathException

  Type-check the expression

  Parameters:
    `env` - the static context of the expression
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten to perform necessary run-time type checks, and to perform other type-related optimizations
  Throws:
    `XPathException`

### equals

    public boolean equals(java.lang.Object other)

  Is this expression the same as another expression?

### hashCode

    public int hashCode()

  get HashCode for comparing two expressions

### getIntrinsicDependencies

    public int getIntrinsicDependencies()

  Determine which aspects of the context the expression depends on. The result is a bitwise-or'ed value composed from constants such as XPathContext.VARIABLES and XPathContext.CURRENT_NODE

  Overrides:
    `getIntrinsicDependencies` in class `ComputedExpression`
  Returns:
    a set of bit-significant flags identifying the "intrinsic" dependencies. The flags are documented in class net.sf.saxon.value.StaticProperty

### computeSpecialProperties

    public int computeSpecialProperties()

  Get the static properties of this expression (other than its type). The result is bit-signficant. These properties are used for optimizations. In general, if property bit is set, it is true, but if it is unset, the value is unknown.

  Overrides:
    `computeSpecialProperties` in class `ComputedExpression`

### getItemType

    public final ItemType getItemType()

  Determine the data type of the items returned by this expression

  Returns:
    Type.NODE or a subtype, based on the NodeTest in the axis step, plus information about the content type if this is known from schema analysis

### computeCardinality

    public final int computeCardinality()

  Specify that the expression returns a singleton

  Specified by:
    `computeCardinality` in class `ComputedExpression`

### getAxis

    public byte getAxis()

  Get the axis

### getNodeTest

    public NodeTest getNodeTest()

  Get the NodeTest. Returns null if the AxisExpression can return any node.

### iterate

    public SequenceIterator iterate(XPathContext context)
                             throws XPathException

  Evaluate the path-expression in a given context to return a NodeSet

  Specified by:
    `iterate` in interface `Expression`
  Overrides:
    `iterate` in class `ComputedExpression`
  Parameters:
    `context` - the evaluation context
  Returns:
    a SequenceIterator that can be used to iterate over the result of the expression
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### display

    public void display(int level,
                        NamePool pool,
                        java.io.PrintStream out)

  Diagnostic print of expression structure

  Parameters:
    `level` - indentation level for this expression
    `pool` - NamePool used to expand any names appearing in the expression
    `out` - Output destination

### toString

    public java.lang.String toString()

  Represent the expression as a string for diagnostics

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD